#ifndef INT_DICT_H
#define INT_DICT_H

#define ID_DEFAULT_SIZE 1009
#define ID_TABLE_MUL 1.4
#define ID_TABLE_ADD 17
#define ID_FILL_LIMIT (0.75)

#include "mach_types.h"

typedef struct id_struct { 
  int table_size;
  int filled;
  int probes;
  int searches;
  struct id_struct *next;
  key_val_p table; } int_dict_t, *int_dict_p;

typedef bool (* id_hook)(void *,int,int);


int_dict_p id_new(int size);
void id_destroy(int_dict_p dict);
void id_map(int_dict_p dict, id_hook func, void *arg);
void id_flatten8(int_dict_p dict, int8_t *array);
void id_flatten16(int_dict_p dict, int16_t *array);
void id_flatten32(int_dict_p dict, int32_t *array);
void id_dump(int_dict_p dict);
void id_grow(int_dict_p dict);
int id_capacity(int_dict_p dict);
int id_filled(int_dict_p dict);
int id_searches(int_dict_p dict);
int id_probes(int_dict_p dict);
int id_report(int_dict_p dict);
key_val_p id_find(int_dict_p dict, int key);
void id_set(int_dict_p dict, int key, int val, bool overwrite);

#endif
