#ifndef _INT_QUEUE_H
#define _INT_QUEUE_H

#include "primtypes.h"
#include "nalloc.h"

typedef struct iq_struct {
  natural_t	size;
  natural_t	head;
  natural_t	tail;
  int		elem[1];	/* Variable size */
} int_queue_t, *int_queue_p;

extern int iq_first(int_queue_p);
extern int_queue_p iq_new(natural_t);
extern int iq_empty(int_queue_p);
extern int iq_count(int_queue_p);
extern int iq_full(int_queue_p);
extern int iq_deq(int_queue_p);
extern void iq_destroy(int_queue_p);
extern void iq_flush(int_queue_p);
extern void iq_enq(int_queue_p, int);
extern na_node_p iq_nalloc(na_node_p, slot_t, natural_t);


#endif
