/**
   macros for manipulating bitmasks
*/

#ifndef _BITMASK_H
#define _BITMASK_H 1

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <math.h>

#include "oms_types.h"

/* The next three macros are courtesy of dougm@rice.edu */

/**
   evaluate to 1 if there is at most one bit set
*/
#define ZERO_OR_POWER_OF_TWO(x) !((x)&((x)-1))

/**
   return the mask with only the least significant bit set
*/

#define LEAST_BIT(x) ((x)&(-x))

/**
   Use IEEE floating point to compute the integer log
*/

#ifdef HAVE_ILOGB
#define LOG2(x)   (ilogb((double)x))
#else
#define LOG2(x) OH_CRAP_MISSING_ILOGB
#endif

typedef  uint32_t bitmask_t;

#define BIT0_MASK 0x1

#endif
