/**
  * @file   primtypes.h
  * @author David Bremner <bremner@unb.ca>
  * @date   Sun Jun 27 14:54:19 2004
  * 
  * @brief  primitive (non-structure) type definitions
  * 
  * Define known size integers.  Currently this is known to work on
  * alpha/linux i386/linux
  */


#ifndef PRIMTYPES_H
#define PRIMTYPES_H

#ifdef HAVE_CONFIG_H
#include "util_config.h"
#endif


#if HAVE_STDBOOL_H
# include <stdbool.h>
#else
# if ! HAVE__BOOL
#  ifdef __cplusplus
typedef bool _Bool;
#  else
#    ifdef __SUNPRO_C
#	pragma error_messages (off, E_KEYWORD_IN_C99)
#    endif 
typedef unsigned char _Bool;
#  endif
# endif
# define bool _Bool
# define false 0
# define true 1
# define __bool_true_false_are_defined 1
#endif

#define TRUE true
#define FALSE false

#ifdef HAVE_INTTYPES_H
#include <inttypes.h>
#else
typedef int int32_t;
typedef short int16_t;
typedef char int8_t;
typedef unsigned char uint8_t;
typedef unsigned short uint16_t;
typedef unsigned int uint32_t;
#endif

/**
 * array_index_t is a type we use to index into arrays.
 * note that index_t, off_t and offset_t cause name collisions
 */

typedef int array_index_t;


typedef int natural_t;
#define NATURAL_T_MAX INT_MAX
typedef int sign_t;


typedef unsigned long rank_t;

#endif
