#ifndef NU_SIGN_H
#define NU_SIGN_H

#include "nu_sign_encoding.h"

/* note, these macros depend intimately on the representation */

#define sign_neg(a) ( (a & SIGN_ZERO) | ( (a & SIGN_NEG ) >> 2) | (( a & SIGN_POS) << 2))

#define sign_subset(a,b) ((a&b)==a)

#define sign_determined(s) ( (s==SIGN_POS ) || (s==SIGN_NEG) || (s==SIGN_ZERO))

#define sign_union(S,x) (S|x)

#define sign_intersection(S,T) (S&T)

#define sign_compatible(S,T) ( (S&T) != 0)
/* multiply a sign by +1, -1 */
#define sign_mulint(s,i) ((i < 0) ? sign_neg(s) : (s))

int sign_int(nu_sign_t sigma);
nu_sign_t int_sign(int i);

#endif
