/*===================================================================*/
/* C program for distribution from the Combinatorial Object Server.  */
/* Generate permutations in lexicographic order. This is             */
/* the same version used in the book "Combinatorial Generation" by   */
/* Frank Ruskey.                                                     */
/* The program can be modified, translated to other languages, etc., */
/* so long as proper acknowledgement is given (author and source).   */  
/* Programmer: Frank Ruskey 19??, Joe Sawada, 1997.                  */
/* The latest version of this program may be found at the site       */
/* http://www.theory.uvic.ca/~cos/inf/perm/PermInfo.html             */
/*===================================================================*/

#include <stdio.h>
static int  n;


void PrintPerm(int *a) {

	int i;
	for (i=1; i <= n; i++) printf( "%d", a[i] );
	printf("\n");
} 

void swap(int *a, int i, int j) {

	int temp;
	temp = a[i];
	a[i] = a[j];
	a[j] = temp;
}

int next_perm(int *a) {
  
  int k,j,r,s;
  
  k = n-1; 
  while (a[k] > a[k+1]) k--;
  if (k == 0) return(0);
  else {
    j = n;
    while (a[k] > a[j]) j--;
    swap(a,j,k);
    r = n; s = k+1;
    while (r>s) {
      swap(a,r,s);
      r--; s++;
    }
  }

  return(1);
}

/** 
 * initialize array.
 * 
 * @param a array to initialize. must have n+1 elements
 * @param n 
 */

extern void first_perm(int *a,int size){
  int i;
  n=size;
  for (i=0; i<=size; ++i) {
    a[i] = i;
  }
}


#if 0
void main () {

	int i;

	printf( "Enter n: " );  scanf( "%d", &n );

	if (n<=0) exit(1); 

	printf( "\n" );
	for (i=0; i<=n; ++i) {
		a[i] = i;
	}
	PrintPerm();
	while (Next());
	printf( "\n" );
}

#endif



