#include <stdio.h>
#include <stdlib.h>
#include <zlib.h>
#include "rusage.h"

static int hash(int k){
  int h=k*123143+23;

 if (h<0) 
   h=h*(-1);
  return h;
}

void usage(){
  fprintf(stderr,"ztest [opts]\n");
  fprintf(stderr,"-l level\n");
  fprintf(stderr,"-b buflen\n");
  fprintf(stderr,"-v vals\n");
  fprintf(stderr,"-t trials\n");
}
int main(int argc , char *argv[]){

  int i,j;
  int result;

  int *inbuf;
  int *outbuf;
  int level=1;
  int buflen=1000;
  int trials=1000;
  int vals=1000;
  double ratio;
  int c;
  double time,copytime;


  while((c=getopt(argc,argv,"l:b:t:v:"))!=-1){
    switch(c){
    case 'l':
      level=atoi(optarg);
      break;
    case 'b':
      buflen=atoi(optarg);
      break;
    case 't':
      trials=atoi(optarg);
      break;
    case 'v':
      vals=atoi(optarg);
      break;
    default:
      usage(argv);
      exit(1);

    }
  }


 
  inbuf=malloc(buflen*sizeof(int));
  outbuf=malloc(buflen*sizeof(int));

  

  for (i=0; i<buflen; i++){
    inbuf[i]=hash(i)%vals;
  }

  time=ru_cputime();
  for (j=0; j< trials; j++){
    for (i=0; i< buflen; i++){
      outbuf[i]+=inbuf[i];
    }
  }
  copytime=(ru_cputime()-time)/trials;

  printf("copy time %f\n",copytime);

 ratio=0;
 for (j=0; j<trials; j++){
   uLongf destlen=buflen*sizeof(int);
   
   result=compress2((char *)outbuf,&destlen,(char *)inbuf,buflen*sizeof(int),level);
   ratio += (double)destlen/(buflen*sizeof(int));
  }

 time=ru_cputime();
 printf("buflen %d (%d)\n",buflen,buflen*sizeof(int));
 printf("trials %d \nlevel %d\nvals %d\n",trials,level,vals);
 printf("compression ratio %f\n",ratio/trials);
 printf("time per run %f\n",time/trials);
 printf("time/copytime %f\n",(time/trials)/copytime);
}

